%Code for MRAC
% This program requires "actual" and "reference" functions

clear all;
clc;
%First order process parameters
ap=1;bp=0.5;
%Reference model parameters
am=2;bm=2;
% Adaptation gain
global gama
gama=2;
%Initial conditions
Yp(1)=0;
Ym(1)=0;
%Generating square reference input
period=20;
N=1000;
T=0.1:0.1:N;
r=square((2*pi/period)*T);

%Finding the output of reference model
ini=0;
for i=2:N
    R=r(i);
    [t1,Ym1]=ode45(@reference,[T(i-1) T(i)],ini,[],R);
    m=length(Ym1);q=length(t1);t11(i)=t1(q);ini=Ym1(m);Ym(i)=Ym1(m);
end
%initial values of Yp,a and b 
x0=[0 1 0.5];
%Finding the output of the plant
for i=2:N
    R=r(i);
    Y=Ym(i);
    [t2,Yp1]=ode45(@actual,[T(i-1) T(i)],x0,[],R,Y);
    m1=length(Yp1);
    %Yp1(m1,1) corresponds to output yp;
    %Yp1(m1,2) corresponds to parameter a;
    %Yp1(m1,3) corresponds to parameter b;
    x0=[Yp1(m1,1) Yp1(m1,2) Yp1(m1,3)]';
    U(i)=Yp1(m1,3)*r(i)-Yp1(m1,2)*Yp1(m1,1);
    Yp(i)=Yp1(m1,1);
end
figure(1)
plot(T(1:1000),Ym,T(1:1000),Yp,'r');
title('Tracking performance');
xlabel('Time');
%ylabel('');
legend('Reference model output','Plant output');
figure(2);
plot(T(1:1000),U);
%title('Plant input(control)');
xlabel('Time ');
ylabel('Control signal');

    
    
