%function gen_phiG for generating gamma and phi

function [gamma,phi]=gen_phiG(A,B,x,y,u);

global N2;
global Nu

m=length(y); 
n=length(u);

%initialize E; {eqn 10.55c}
E=1;             

%evaluate atilde
na=size(A,2)-1;
Atilde(1)=1;
for i=2:na+1
    Atilde(i)=A(i)-A(i-1);
end
Atilde(na+2)=-A(na+1);  

%initialize F; {eqn 10.55c}
for i=1:na+1
    F(i)=-Atilde(i+1);
end
F(na+2)=0;

%initialize g=E*B
g=mult(E,B);

%evaluate delta u
for i=1:n
    if(i==1)
        del_u(1)=u(1);
    else
        del_u(i)=u(i)-u(i-1);
    end
end

%generate recursively phi and g
for j=1:N2
    size_g=length(g);
    size_F=length(F);
    
    phi1=0;  %phi1=z^(j-1)[gj-gbarj]*del_u(k); (eqn 10.56}
    for i=j+1:size_g
        if(m-i+j+1==0)
            break;
        end
        phi1=phi1+g(i)*del_u(n-i+j+1);
    end
    
    phi2=F(1)*x;  %phi2=Fj*y(k); {eqn 10.56}
    for i=2:size_F
        if(m-i+2<=0)
            break;
        end
        phi2=phi2+F(i)*y(m-i+2);
    end
    
    phi(j)=phi1+phi2;
    
    %update E; {eqn 10.55a}
    E=[E F(1)];  
    
    %update F; {eqn 10.55b}
    for i=1:na+1
        F1(i)=F(i+1)-Atilde(i+1)*F(1);
    end
    F1(na+2)=0;
    clear F;
    F=F1;
    clear F1;
    g=mult(E,B);
end

g=mult(E,B);

gamma=zeros(N2,Nu);

%generate G matrix
for j=1:Nu
    for i=1:(N2-j+1)
        gamma(i+j-1,j)=g(i);
    end
end