clc
clear all;
close all;
disp('Refer Example 4.3')
%Direct Digital Design(lag compensation)
%Uncompensated system
G=tf(50,[1 5 0]);
%Discretization
Gz=c2d(G,0.1);Gz1=zpk(Gz);
%Design in w-domain
Gw=d2c(Gz,'tustin');
figure(1);
margin(Gw);
%Read uncompensated phase margin from figure 1.
w=logspace(-1,1,100);
[mag,ph]=bode(Gw,w);
%mag and ph are arrays; Matlab function interp1
%does not work with these arrays. Reshape the
%arrays into column vectors.
mag=reshape(mag,100,1);
ph=reshape(ph,100,1);
%Phi=-180+specified phase margin+epsilon=-130
Phi=input('Enter phase angle Phi: ');
%Select frequency range properly; function interp1
%requires monotonic data.
wc2=interp1(ph,w,Phi)
%wc2 is the desired gain crossover
beta=interp1(ph,mag,Phi);
%Upper corner frequency at wc2/4
wcu=input('Enter upper corner frequency:')
tau=1/wcu;
Dw=tf([tau 1],[beta*tau 1])
%Digital controller
D=c2d(Dw,0.1,'tustin');
Dz=zpk(D)
figure(2);
%Read phase margin of the compensated system
%from figure 2
margin(Dw*Gw);
%Bandwidth(Uncompensated & compensated)
w=[5:0.1:15];
[mag,ph,w]=bode(feedback(Gw,1));
magdB=20*log10(mag);
wb=interp1q(-magdB,w,3)
[mag1,ph1,w]=bode(feedback(Dw*Gw,1));
mag1dB=20*log10(mag1);
wb1=interp1q(-mag1dB,w,3)
%Analysis on Nichols chart
figure(3)
Gwc=Dw*Gw;
nichols(Gw,Gwc);ngrid;
%Step-response analysis using GUI
Mz=feedback(D*Gz,1);
figure(4)
step(Mz);

