clc
clear all
close all
disp('Refer Example 4.8');

G=tf([1], [10 1 0]);
GhoG=c2d(G,1,'zoh');
Zpk(GhoG)
figure(1)
margin(GhoG);grid;
% Observe Fig 1. It is clear that with a compensator of gain K=1, the system has
% a PM of 9.18deg and a gain crossover frequency(Wcg) of 0.308 rad/sec.
% The 16% overshoot requirement translates into zeta>0.5,which translates in turn
% to the requirement that Wcg>=0.92rad/sec and PM>50deg(required guidelines of design)
% The following trial compensator satisfies the Kv requirement;
% the trial value of compensator zero is 0.85
% and that of pole is 0

D1=tf(6.67*[1 -0.85],[1 0],1);
G1=D1*GhoG;
figure(2)
margin(G1);grid;
% Observe Fig 2. There is no increase in the slope of the magnitude curve
% at a low enough frequency to bring about the desired Wcg
% Let us change the zero location; gain gets adjusted to satisfy the Kv 

D2=tf(10*[1 -0.9],[1 0],1);
G2=D2*GhoG;
figure(3)
margin(G2);grid;
% Observe Fig 3. We got a  Wcg of 0.887 rad/sec, but the resulting 
% PM of 40 deg was still lower than desired
% Change the pole location; gain gets adjusted to satisfy the Kv

D3=tf(15*[1 -0.9],[1 0.5],1);
G3=D3*GhoG;
figure(4)
margin(G3);grid;
% Observe Fig 4. We have very little effect on the Wcg but achieved 
% an increase in the PM to 52.3 deg . 
% It seems that this controller works better but we have to check 
% its performance in time domain as the conversion of specifications is approximate

figure(5)
step(G3/(1+G3));grid;
% Observe Fig 5 and use GUI. The settling time is 5 sec but the overshoot
% is 27% So we go for another attempt

% The guidelines were not successful in meeting the specifications 
% because the system is third order with zero, whereas the rules were
% derived assuming a second-order system without a zero.

D4=tf(10*[1 -0.85],[1 0.5],1);
G4=D4*GhoG;
figure(6)
margin (G4);grid;
% Observe Fig 6. We got a 60deg PM (very much higher than required) 
% and a 0.6 rad/sec Wcg(less than the required)

D5=tf(12.8*[1 -0.883],[1 0.5],1);
G5=D5*GhoG;
figure(7)
margin (G5);grid;
% Observe Fig 7. We got a 57.1deg PM and a 0.82 rad/sec Wcg

figure(8)
step(G5/(1+G5));grid;
% Observer Fig 8. It exactly meets the requirements for 16% overshoot and ts=10 sec. 